/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	LO Exchange教材 サーバクラス
//			変更履歴
//				2004.01.08	新規作成	市川勇次
//
package jp.co.ntt.lms.lo.Exchange;

import jp.co.ntt.lms.lo.*;
import jp.co.ntt.lms.xmo.util.*;

import jp.co.ntt.lms.xmo.Lo.MaterialData;	// @pending この教材データオブジェクトは将来パッケージを変える
import jp.co.ntt.lms.xmo.MenuData;
import jp.co.ntt.lms.xmo.MessageData;

import java.rmi.Naming;
import java.rmi.RemoteException;
import java.rmi.RMISecurityManager;

import java.util.*;
import java.sql.*;

/**
 * LO Exchange教材 サーバクラスです。<BR>
 * 要求を受けたLOのメニューリストを作成して返します
 * RMIサーバとして動作するためRemoteインタフェースであるLoTopインタフェースを実装し、
 * 永続的な起動状態を確保するためjava.rmi.server.UnicastRemoteObjectクラスを継承します。
 * @author Y.Ichikawa
 * @version 0.0.0.1 2004/01/08
 */
public class ExchangeLo extends LoServer
	implements LoTop, LoPropertyDef, ExchangeLoTable
{

	//////////////////////////////////////////////////////////////////
	// メソッド名定義
	//////////////////////////////////////////////////////////////////

	/**
	 * コンストラクタです。
	 */
	public ExchangeLo() throws LOException, RemoteException {
		// リモートオブジェクトをエクスポートする
		// java.rmi.server.UnicastRemoteObject の
		// 引数なしのコンストラクタを呼び出す
		super();

		// 教材構造ファイルをすべてロードします
		try {
			mobjMenuMakerIF = new ExchangeMenuMaker();
			mobjLearnManagerIF = new ExchangeLearnManager();
			mobjSetupIF = new ExchangeSetup();
		}
		catch( Exception e ) {
			throw new LOException( this.getClass().getName() + " :: ロード失敗 " );
		}
	}

	/**
	 * 教材一覧を返します
	 *
	 * @param Hashtable パラメータリスト
	 * @return Vector メッセージデータと教材一覧
	 */
	public Vector getMaterialList( Hashtable htbParam )
	{
		DebugLog.write( this.getClass(), "#########################################", DebugLog.ROW );
		DebugLog.write( this.getClass(), "     Exchange教材: getMaterialList Start", DebugLog.ROW );
		DebugLog.write( this.getClass(), "#########################################", DebugLog.ROW );

		return new Vector();
	}
	/**
	 * データ取得処理
	 *
	 * @param String
	 * @param Hashtable パラメータリスト
	 * @return Vector メッセージデータと実行結果データ
	 */
	public Vector getData(Hashtable htbParam)
	{
		Vector vecRet     = new Vector();
		MessageData objMd = null;
		Object objRet     = null;
		try {
			ExchangeLoDataAccess objDataAccess = new ExchangeLoDataAccess();
			objRet = objDataAccess.getData( htbParam );
		}
		catch(LOException le) {
			// メッセージデータオブジェクトが取得できない場合は
			// システムエラーメッセージオブジェクトを生成
			objMd = createSystemErrMessage(le.getMessage());
		}
		vecRet.add(objMd);
		vecRet.add(objRet);
		return vecRet;
	}
}
